CF 1447F2 Frequency Problem (Hard Version)

题目描述

https://codeforces.com/contest/1447/problem/F2

简要题意:给定一个长度为 $n$ 的序列 $a_i$,求最长的一个区间 $[l,r]$ 满足这个区间的众数有至少两个

$n\le 2\times 10^5$

Solution

首先有一个比较显然的性质,整个序列的众数一定是答案区间的众数之一

我们考虑根号分治,不妨设整个序列的众数为 $p$

对于出现次数大于 $\sqrt n$ 的数 $v$,这些数的个数不会超过 $\sqrt n$ 个

我们对于每个 $v$,把出现一个 $v$ 当做加一,出现 $p$ 当做减一,然后通过前缀和对于一个 $v$ 可以 $O(n)$ 统计答案

注意到可能有一个小问题就是可能统计的区间中出现次数最多的数并不是 $p$ 和枚举到的 $v$

如果是这样的话,这个区间一定能变得更大,所以不会影响答案

对于出现次数小于 $\sqrt n$ 的数,我们直接枚举答案区间的众数的出现次数 $k$,然后对于每个 $k$,如果固定左端点,则最远的合法右端点是一个定值,且随着左端点的增加而增加,所以可以直接双指针

总的时间复杂度为 $O(n\sqrt n)$

1
2
3
4
5
6
7
8
9
10
11
12
13
14
15
16
17
18
19
20
21
22
23
24
25
26
27
28
29
30
31
32
33
34
35
36
37
38
39
40
41
42
43
44
45
46
47
48
49
50
51
52
53
54
55
56
57
58
59
60
61
62
63
64
65
#include <iostream>
#include <cstdio>
#include <cmath>
#include <cstring>
#define maxn 200010
using namespace std;

int n, m, a[maxn];

struct Cnt {
int cnt[maxn], Cnt[maxn], num;

void init() { }

inline void add(int x) {
--Cnt[cnt[x]];
if (++cnt[x] > num) ++num;
++Cnt[cnt[x]];
}

inline int Add(int x) { return max(num, cnt[x] + 1); }

inline void del(int x) {
if (--Cnt[cnt[x]] == 0 && cnt[x] == num) --num;
--cnt[x];
++Cnt[cnt[x]];
}
} _;

int cnt[maxn];

const int offset = 200000;
int f[maxn * 2];

int ans;
int main() {
ios::sync_with_stdio(false);
cin.tie(nullptr);

cin >> n; int S = sqrt(n);
for (int i = 1; i <= n; ++i) cin >> a[i], ++cnt[a[i]];
int mx = 0, p;
for (int i = 1; i <= n; ++i)
if (cnt[i] > mx) mx = cnt[i], p = i;
for (int i = 1; i <= n; ++i) {
if (cnt[i] <= S || i == p) continue;
memset(f, -1, sizeof f); f[offset] = 0; int s = 0;
for (int j = 1; j <= n; ++j) {
if (a[j] == p) --s;
else if (a[j] == i) ++s;
if (~f[s + offset]) ans = max(ans, j - f[s + offset]);
else f[s + offset] = j;
}
}
for (int limit = 1; limit <= S; ++limit) {
int j = 0;
for (int i = 1; i <= n; ++i) {
while (j < n && _.Add(a[j + 1]) <= limit) _.add(a[++j]);
if (_.Cnt[limit] >= 2) ans = max(ans, j - i + 1);
_.del(a[i]);
}
} cout << ans << endl;
return 0;
}